<?php
defined('BASEPATH') or exit('No direct script access allowed');

class FileDownload extends CI_Controller
{

    protected $rutaDiaria = FCPATH . "DOWNLOADS/DAILY/";
    protected $rutaDiariaFormat = FCPATH . "DOWNLOADS/DAILY/format/";
    protected $rutaMensual = FCPATH . "DOWNLOADS/MONTH/";
    protected $enlaceAtom = "";

    public function __construct()
    {
        parent::__construct();
        $this->load->helper('file');
        $this->load->helper('xml');
    }

    public function index()
    {
        $this->downloadProcess();
    }

    private function downloadProcess()
    {
        $fileName = basename(URL_DIARIA);
        $this->downloadFile($fileName, URL_DIARIA, $this->rutaDiaria);

        $archivoAtom = $this->getFile($this->rutaDiaria . $fileName, $fileName);
        $nuevoAtomAttrNext = $this->readNextAttribute($archivoAtom);

        //while ($nuevoAtomAttrNext !== "") {
        $aux = 0;
        while ($aux <= 3) {

            $fileName = basename($nuevoAtomAttrNext);
            $this->downloadFile($fileName, $nuevoAtomAttrNext, $this->rutaDiaria);
            $archivoAtom = $this->getFile($this->rutaDiaria . $fileName, $fileName);

            $nuevoAtomAttrNext = $this->readNextAttribute($archivoAtom);
            $aux++;
        }
    }

    private function getFile($url = URL_DIARIA, $fileName)
    {

        $feed = implode(file($url));
        $xml = simplexml_load_string($feed);
        $json = json_encode($xml);
        $array = json_decode($json, true);

        $this->formatXml($feed, $fileName);
        return $array;
    }

    private function formatXml($xml, $fileName)
    {
        $openingFormat = $this->regExIniciosEsquema($xml);
        $closureFormat = $this->regExFinalesEsquema($openingFormat);
        file_put_contents($this->rutaDiariaFormat . $fileName, $closureFormat);
    }

    private function readNextAttribute($archivo)
    {
        $enlace = "";
        foreach ($archivo['link'] as $row) {
            $attrNext = $row['@attributes']['rel'];
            $attrHref = $row['@attributes']['href'];

            if ($attrNext === "next") {
                $enlace = $attrHref;
            }
        }

        return $enlace;
    }

    private function downloadFile($fileName, $url, $ruta)
    {
        if (file_put_contents($ruta . $fileName, file_get_contents($url))) {
            return true;
        } else {
            return false;
        }
    }

    private function regExIniciosEsquema($xml)
    {
        $pattern = "/(<cac:)|(<cbc:)|(<cac-place-ext:)|(<cbc-place-ext:)/";
        $result = preg_replace($pattern, "<", $xml);

        return $result;
    }

    private function regExFinalesEsquema($xml)
    {
        $pattern = "/(<\/cac:)|(<\/cbc:)|(<\/cac-place-ext:)|(<\/cbc-place-ext:)/";
        $result = preg_replace($pattern, "</", $xml);

        return $result;
    }

}
